import sys
import re
from authorization_utils import *
from aps_utils import *

def getvins():
    with open("vins.txt", "r", encoding="utf-8") as file:
        lines = [line.strip() for line in file if line.strip()]
    return lines


def clear_app(vins, param):
    pattern = r'^[0-9a-fA-F]{8}-([0-9a-fA-F]{4}-){3}[0-9a-fA-F]{12}\s*$'
    if re.fullmatch(pattern, param):
        print("[INFO] clear app desired state by uid")
        clearfunc = appdesired_clearbyuid
    else:
        print("[INFO] clear app desired state by name")
        clearfunc = appdesired_clearbyname

    for vin in vins:
        print('handle vin: ' + vin)
        masterid, nonmasterids = getusers(vin)

        # if masterid is not bound, it may be a prod vehicle
        if not masterid: continue

        #clear non-master user desired
        for meid in nonmasterids:
            post_apsdesired(vin, meid, clearfunc(vin, meid, param))

        #clear master user desired
        post_apsdesired(vin, masterid, clearfunc(vin, masterid, param))


args = sys.argv
argsNum = len(args)

if argsNum != 2:
    print('[ERROR]app name or app uid is missing')
else:
    clear_app(getvins(), args[1])